# $Id: Install.py,v 1.5 2002/03/13 14:57:51 gitte Exp $
# $Source: /usr/local/cvs_root//OnlinePIM/Extensions/Install.py,v $
__version__ = "$Revision: 1.5 $"[11:-2]

from Products.CMFCore.TypesTool import ContentFactoryMetadata
from Products.CMFCore.DirectoryView import DirectoryView, addDirectoryViews, createDirectoryView
from Products.CMFCore.utils import getToolByName, minimalpath
from Products.OnlinePIM import pim_globals, Contact, ContactContainer, Desktop, EventContainer, Profile, Reference
from App.Common import package_home
from os import path, listdir, stat
from cStringIO import StringIO
import string
import zLOG

def Install(self):
    """Register Online PIM with the necessary tools"""
    out = StringIO()
    typestool = getToolByName(self, 'portal_types')
    skinstool = getToolByName(self, 'portal_skins')
    
    type_classes = (Contact, ContactContainer, Desktop, EventContainer, Profile, Reference)
    
    for c in type_classes:
        t = c.factory_type_information
        if t['id'] not in typestool.objectIds():
            cfm = apply(ContentFactoryMetadata, (), t)
            typestool._setObject(t['id'], cfm)
            out.write('Registered %s with the types tool\n' % t['id'])
        else:
            out.write('Object "%s" already existed in the types tool\n' % t['id'])
        
    # Setup the skins
    if 'pim_skins' not in skinstool.objectIds():
        # We need to add Filesystem Directory Views for any directories
        # in our skins/ directory.  These directories should already be
        # configured.
        fp = minimalpath("%s/zpt_skins" % package_home(pim_globals))
        createDirectoryView(skinstool, fp, 'pim_skins')
        out.write("Added %s directory view to portal_skins\n" % fp)
    else:
        out.write("'pim_skins' directory view already existed in portal_skins\n")


    # Now we need to go through the skin configurations and insert
    # 'pim_skins' into the configurations.  Preferably, this
    # should be right before where 'content' is placed.  Otherwise, we
    # append it to the end.
    skins = skinstool.getSkinSelections()
    for skin in skins:
        path = skinstool.getSkinPath(skin)
        path = map(string.strip, string.split(path,','))
        if 'pim_skins' not in path:
            try: path.insert(path.index('content'), 'pim_skins')
            except ValueError:
                path.append('pim_skins')

            path = string.join(path, ', ')
            # addSkinSelection will replace existing skins as well.
            skinstool.addSkinSelection(skin, path)
            out.write("Added 'pim_skins' to %s skin\n" % skin)
        else:
            out.write("Skipping %s skin, 'pim_skins' is already set up\n" % skin)

    return out.getvalue()

def test(self):
    """Test CMFArticle installation"""
    out = StringIO()
    skinstool = getToolByName(self, 'portal_skins')

    # Setup the skins
    if 'article' not in skinstool.objectIds():
        out.write("'article' not in portal_skins\n")
    else:
        out.write("'article' is in portal_skins\n")

    # Setup the skins
    if 'ptarticle' not in skinstool.objectIds():
        out.write("'ptarticle' not in portal_skins\n")
    else:
        out.write("'ptarticle' is in portal_skins\n")

    for dir in skinstool.objectIds():
        path = getattr(skinstool, dir)
        out.write("Dir %s / %s\n" % (dir, str(path)) )

    # Now we need to go through the skin configurations and insert
    # 'article' into the configurations.  Preferably, this
    # should be right before where 'content' is placed.  Otherwise, we
    # append it to the end.
    skins = skinstool.getSkinSelections()

    for skin in skins:
        path = skinstool.getSkinPath(skin)
        path = string.split(path,',')
        out.write("Skin %s: %s \n" % (skin, path) )

    return out.getvalue()
