##############################################################################
#    Copyright (C) 2001  MMmanager.org
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#
##############################################################################
"""
"""

ADD_CONTENT_PERMISSION = 'Add portal content'

#Globals
import Globals
import zLOG
import string
from AccessControl import ClassSecurityInfo
from DateTime.DateTime import DateTime
from Acquisition import aq_parent, aq_inner, aq_base

#CMF
from Products.CMFCore import CMFCorePermissions
from Products.CMFCore.CMFCorePermissions import View
from Products.CMFCore.CMFCorePermissions import ManageProperties
from Products.CMFCore.PortalContent import PortalContent
from Products.CMFDefault.DublinCore import DefaultDublinCoreImpl

factory_type_information = {
      'id': 'Profile',
      'meta_type': 'PIM Profile',
      'description': 'Use profile object to store profile data',
      'product': 'OnlinePIM',
      'icon': 'clip_icon.png',
      'factory': 'addProfile',
      'filter_content_types': 0,
      'immediate_view': 'profile_edit_form',
      'actions': 
	      ({'name': 'View',
	        'action': 'profile_view',
		'permissions': ('View',),
		'category': 'object'},
	       {'name': 'Edit',
	        'action': 'profile_edit_form',
		'permissions': ('Modify portal content',),
		'category': 'object'})
       }


class Profile( PortalContent
          , DefaultDublinCoreImpl
          ):
    """
        A Profile
    """

    meta_type='PIM Profile'
    portal_type='Object'
    effective_date = expiration_date = None
    _isDiscussable = 1

    security = ClassSecurityInfo()

    def __init__( self
                , id
                , title=''
                , description=''
                ):
        DefaultDublinCoreImpl.__init__(self)
        self.id=id
        self.title = title
        self.show_title = 0
        self.description = description
        self.show_description = 0
	self.age = ''
	self.show_age = 0
	self.sex = ''
	self.show_sex = 0
	self.hair_color = ''
	self.eye_color = ''
	self.height = ''
	self.weight = ''
	self.location = ''
	self.show_location = 0
	self.pic_path = ''
	self.show_pic = 0

    def SearchableText(self):
        """
            text for indexing
        """
        return "%s %s" % (self.title, self.description)

    security.declareProtected(ManageProperties, 'edit')
    def edit(self, title=None, show_title=None, description=None, show_description=None, age=None, show_age=None, sex=None, show_sex=None, hair_color=None, eye_color=None, height=None, weight=None, location=None, show_location=None, pic_path=None, show_pic=None):

	if title is not None:
	   self.setTitle(title)
	   
	if show_title is not None:
	    self.show_title = show_title

	if description is not None:
	   self.setDescription(description)
	   
	if show_description is not None:
	    self.show_description = show_description

	if age is not None:
	   self.age = age
	   
	if show_age is not None:
	    self.show_age = show_age

	if sex is not None:
	   self.sex = sex
	   
	if show_sex is not None:
	    self.show_sex = show_sex

	if hair_color is not None:
	   self.hair_color = hair_color

	if eye_color is not None:
	   self.eye_color = eye_color

	if height is not None:
	   self.height = height

	if weight is not None:
	   self.weight = weight

	if location is not None:
	   self.location = location
	   
	if show_location is not None:
	    self.show_location = show_location

	if pic_path is not None:
	   self.pic_path = pic_path
	   
	if show_pic is not None:
	    self.show_pic = show_pic
	    
    security.declarePublic('getPicSrc')
    def getPicSrc(self):
        try:
            picobj = self.restrictedTraverse(self.picpath)
            picsrc = picobj.absolute_url()
        except:
            picsrc = 'def_profilepic.gif'
        return picsrc

    security.declarePublic('getParent')
    def getParent(self):
	parent = self.aq_inner.aq_parent
	return parent
	
def addProfile(self, id, title='', REQUEST=None):
	ob = Profile(id,title)
	self._setObject(id, ob)

Globals.InitializeClass(Profile)

from Products.CMFCore.register import registerPortalContent
registerPortalContent(Profile,
                      constructors=(addProfile,),
		      action='profile_edit_form',
		      icon='clip_icon.png')
